﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using RestCalculatorServiceCore31.Model;

// For more information on enabling Web API for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

//"https://localhost:44389/api/calculator/"; //IISExpress
//"https://localhost:5001/api/calculator/"; //Program console
//"https://miclrestcalculatorcore.azurewebsites.net/api/calculator/"; //Azure URI

namespace RestCalculatorServiceCore31.Controllers
{
    [Route("[controller]")] //actually could also have api/controller no problem
    [ApiController]
    public class CalculatorController : ControllerBase
    {
        // GET: api/Calculator
        [HttpGet]
        public IEnumerable<string> Get()
        {
            return new string[] { "value1", "value2" };
        }

        // GET: api/Calculator/5
        [HttpGet("{id}", Name = "Get")]
        public int Get(int id)
        {
            return id; //.ToString();
        }
        //Calculator code starts here


        // POST: api/Calculator
        [HttpPost("Sub", Name = "Sub")]
        public int Post1([FromBody] Data data)
        {
            return data.A - data.B;
        }

        // POST: api/Calculator
        [HttpPost("Add", Name = "Add")]
        public int Post([FromBody] Data data)
        {
            return data.A + data.B;
        }


        // POST: api/Calculator
        [HttpPost("Mul", Name = "Mul")]
        public int Post2([FromBody] Data data)
        {
            return data.A * data.B;
        }

        // POST: api/Calculator
        [HttpPost("Div", Name = "Div")]
        public double Post3([FromBody] Data data)
        {
            if (data.B != 0)
                return (1.0 * data.A) / data.B;
            else throw new DivideByZeroException("Division by zero");
        }

        // PUT: api/Calculator/5
        [HttpPut("{id}")]
        public void Put(int id, [FromBody] string value)
        {
        }

        // DELETE: api/ApiWithActions/5
        [HttpDelete("{id}")]
        public void Delete(int id)
        {
        }
    }
}
